'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-MoleculeSelect-inputSelect';
var CLASS_CONTAINER = BASE_CLASS + '-container';
var CLASS_ARROW = BASE_CLASS + '-arrow';
var CLASS_ARROW_DOWN = CLASS_ARROW + '--down';
var CLASS_ARROW_UP = CLASS_ARROW + '--up';

exports.default = function (BaseComponent) {
  var _class, _temp;

  var displayName = BaseComponent.displayName;
  return _temp = _class = function (_Component) {
    (0, _inherits3.default)(WithSelectUI, _Component);

    function WithSelectUI() {
      (0, _classCallCheck3.default)(this, WithSelectUI);
      return (0, _possibleConstructorReturn3.default)(this, (WithSelectUI.__proto__ || (0, _getPrototypeOf2.default)(WithSelectUI)).apply(this, arguments));
    }

    (0, _createClass3.default)(WithSelectUI, [{
      key: 'render',
      value: function render() {
        /* eslint-disable react/prop-types */
        var _props = this.props,
            onClick = _props.onClick,
            iconArrow = _props.iconArrowDown,
            iconArrowUp = _props.iconArrowUp,
            isOpen = _props.isOpen,
            props = (0, _objectWithoutProperties3.default)(_props, ['onClick', 'iconArrowDown', 'iconArrowUp', 'isOpen']);
        var classNames = this.classNames;

        return _react2.default.createElement(
          'div',
          { className: CLASS_CONTAINER, onClick: onClick },
          _react2.default.createElement(BaseComponent, (0, _extends3.default)({}, props, { readOnly: true })),
          _react2.default.createElement(
            'span',
            { className: classNames },
            iconArrow
          )
        );
      }
    }, {
      key: 'classNames',
      get: function get() {
        var _cx;

        var isOpen = this.props.isOpen; // eslint-disable-line react/prop-types

        return (0, _classnames2.default)(CLASS_ARROW, (_cx = {}, (0, _defineProperty3.default)(_cx, CLASS_ARROW_DOWN, !isOpen), (0, _defineProperty3.default)(_cx, CLASS_ARROW_UP, isOpen), _cx));
      }
    }]);
    return WithSelectUI;
  }(_react.Component), _class.displayName = 'withSelectUI(' + displayName + ')', _temp;
};